# Interface Flow.Processor<T,R>

Type Parameters:
  `T` - the subscribed item type
  `R` - the published item type

All Superinterfaces:
  `Flow.Publisher<R>, Flow.Subscriber<T>`

Enclosing class:
  `Flow`

public static interface Flow.Processor<T,R> extends Flow.Subscriber<T>, Flow.Publisher<R>
A component that acts as both a Subscriber and Publisher.

Since:
  9

## Method Summary

### Methods declared in interface Flow.Publisher

`subscribe`
Modifier and Type
Method
Description
`void`
`subscribe(Flow.Subscriber<? super R> subscriber)`
Adds the given Subscriber if possible.

### Methods declared in interface Flow.Subscriber

`onComplete, onError, onNext, onSubscribe`
Modifier and Type
Method
Description
`void`
`onComplete()`
Method invoked when it is known that no additional Subscriber method invocations will occur for a Subscription that is not already terminated by error, after which no other Subscriber methods are invoked by the Subscription.
`void`
`onError(Throwable throwable)`
Method invoked upon an unrecoverable error encountered by a Publisher or Subscription, after which no other Subscriber methods are invoked by the Subscription.
`void`
`onNext(T item)`
Method invoked with a Subscription's next item.
`void`
`onSubscribe(Flow.Subscription subscription)`
Method invoked prior to invoking any other Subscriber methods for the given Subscription.